--[[ Mortar
	Mortar Script
	for CS2D
	by Bolt_PL (USGN#88318)
	!mortar_place	- create new mortar
	!mortar_remove	- remove mortar from this tile
	!mortar_debug	- debugging not needed, bug removed so !mortar_debug removed
]]--
function array(m,v)
	local t={}
	for i=1,m do
		t[i]=v
	end
	return t
end
function distance(x1,y1,x2,y2)
	local dist1=(x1-x2)^2
	local dist2=(y1-y2)^2
	local d=dist1+dist2
	d=math.sqrt(d)
	d=math.floor(d)
	return d
end
mrt={}
mrt.admins={88318}	--your usgns here
mrt.v=10			--tiles per second time=distance/mrt.v  +1
mrt.size=100		--explosion size in pixels

mrt.using=array(32,0)
mrt.mortars={}
mrt.x=array(32,0)
mrt.y=array(32,0)
mrt.timer=array(32,0)
mrt.projectile=array(32,0)
mrt.shot=array(32,0)
mrt.target=array(32,0)
function mrt.fire(id,x,y)
	local t
	local s=distance(x,y,player(id,"tilex"),player(id,"tiley"))
	t=math.ceil(s/mrt.v)+1
	mrt.timer[id]=t
end

addhook("use","mrt.use")
function mrt.use(id)
	local x=player(id,"tilex")
	local y=player(id,"tiley")
	for i=1,#mrt.mortars do
		if mrt.mortars[i][1]==x and mrt.mortars[i][2]==y and mrt.mortars[i][3]==0 then
			mrt.using[id]=i
			parse('hudtxt2 '..id..' 1 "Mortar ready to launch" 420 460 1')
			mrt.mortars[i][3]=1
		end
	end
end
addhook("attack","mrt.click")
function mrt.click(id)
	if mrt.using[id]>0 and mrt.timer[id]>=0 then
		reqcld(id,2)
	end
end
addhook("clientdata","mrt.data")
function mrt.data(id,mode,data1,data2)
	if mode==2 then
		data1=math.floor(data1/32)
		data2=math.floor(data2/32)
		parse('hudtxt2 '..id..' 1')
		parse('hudtxt2 '..id..' 2')
		mrt.fire(id,data1,data2)
		mrt.x[id]=data1
		mrt.y[id]=data2
		mrt.shot[id]=1
		parse('hudtxt2 '..id..' 2 "Target locked: x='..data1..'/y='..data2..'" 420 440 1')
		freeimage(mrt.target[id])
		mrt.target[id]=0
		mrt.target[id]=image("sys/lua/mortar_target.bmp",mrt.x[id]*32+16,mrt.y[id]*32+16,1,id)
	end
end
addhook("second","mrt.ms")
function mrt.ms()
	for id,v in pairs(mrt.using) do
		if  mrt.timer[id]>0 and mrt.shot[id]==1 then
			mrt.timer[id]=mrt.timer[id]-1
			parse('hudtxt2 '..id..' 1 "Mortar timer: '..mrt.timer[id]..'" 420 460 1')
		else
			
		end
		if mrt.timer[id]<=0 and mrt.shot[id]==1 then
			mrt.shot[id]=0
			mrt.timer[id]=0
			local x=mrt.x[id]*32+16
			local y=mrt.y[id]*32+16
			freeimage(mrt.target[id])
			mrt.target[id]=0
			parse('hudtxt2 '..id..' 1')
			parse('hudtxt2 '..id..' 2')
			parse("explosion "..x.." "..y.." "..mrt.size.." 85 "..id.."")
			parse('hudtxt2 '..id..' 1 "Mortar ready to launch" 420 460 1')
		end
	end
end

addhook("say","mrt.say")
function mrt.say(id,txt)
	for _,admin in pairs(mrt.admins) do
		if admin==player(id,"usgn") then
			if txt:sub(1,13)=="!mortar_place" then
				table.insert(mrt.mortars,{player(id,"tilex"),player(id,"tiley"),0,0})
				local max=#mrt.mortars
				mrt.mortars[max][4]=image("sys/lua/mortar.png",player(id,"tilex")*32+16,player(id,"tiley")*32+16,0,0)
				return 1
			elseif txt:sub(1,14)=="!mortar_remove" then
				for i=1,#mrt.mortars do
					if mrt.mortars[i][1]==player(id,"tilex") and mrt.mortars[i][2]==player(id,"tiley") and mrt.mortars[i][3]==0 then
						freeimage(mrt.mortars[i][4])
						table.remove(mrt.mortars,i)
					end
				end
				return 1
			end
		end
	end
end
addhook("movetile","mrt.move")
function mrt.move(id,x,y)
	if mrt.mortars[mrt.using[id]]~=nil and mrt.using[id]~=0 then
		mrt.mortars[mrt.using[id]][3]=0
		mrt.using[id]=0
		parse('hudtxt2 '..id..' 1')
	end
end
addhook("die","mrt.die")
addhook("leave","mrt.die")
function mrt.die(id)
	if mrt.mortars[mrt.using[id]]~=nil then
		mrt.mortars[mrt.using[id]][3]=0
		mrt.using[id]=0
		parse('hudtxt2 '..id..' 1')
		parse('hudtxt2 '..id..' 2')
	end
end
